Main
Sub Main()
Set ap = CreateObject("Illustrator.Application")
Set doc = ap.ActiveDocument
Set newCMYKColor = CreateObject("Illustrator.CMYKColor")

sl = doc.Selection

Set slpath = sl(0)

If slpath.TypeName = "PathItem" Then
    Set nGroup = doc.GroupItems.Add
    For Each p In slpath.PathPoints
        ld = p.LeftDirection
        aa = p.Anchor(0)
        rd = p.RightDirection
        
        WhatAngleType ld, aa, rd, newCMYKColor
        
        x = aa(0): y = aa(1)
        Set elps = nGroup.PathItems.Ellipse(y + 5, x - 5, 10, 10)
        elps.FillColor = newCMYKColor
        elps.Stroked = False
        elps.BlendingMode = aiDarken

    Next
    nGroup.Locked = True
ElseIf slpath.TypeName = "CompoundPathItem" Then
    For Each s In slpath.PathItems
    
        Set nGroup = doc.GroupItems.Add
        For Each p In s.PathPoints
            ld = p.LeftDirection
            aa = p.Anchor(0)
            rd = p.RightDirection
            
            WhatAngleType ld, aa, rd, newCMYKColor
            
            x = aa(0): y = aa(1)
            Set elps = nGroup.PathItems.Ellipse(y + 5, x - 5, 10, 10)
            elps.FillColor = newCMYKColor
            elps.Stroked = False
            elps.BlendingMode = aiDarken

        Next
        nGroup.Locked = True
    Next
Else
    Exit Sub
End If

End Sub
'=============================================================================

Sub WhatAngleType(ld, aa, rd, newCMYKColor)

If (aa(0) = ld(0) And aa(1) = ld(1)) Or (aa(0) = rd(0) And aa(1) = rd(1)) Then
    If (ld(0) = rd(0) And ld(1) = rd(1)) Then
        TypeAngle = "without handles"
    Else
        TypeAngle = "only one handle"
    End If

ElseIf ld(0) = rd(0) Or ld(1) = rd(1) Then
    d1 = aa(0) - ld(0): d1 = trimval(d1)
    d2 = rd(0) - aa(0): d2 = trimval(d2)
    d3 = aa(1) - rd(1): d3 = trimval(d3)
    d4 = ld(1) - aa(1): d4 = trimval(d4)
    If d1 = d2 And d3 = d4 Then
        TypeAngle = "symmetrical"
    Else
        TypeAngle = "smooth"
    End If

ElseIf (ld(0) = aa(0) And aa(0) <> rd(0)) Or (ld(0) <> aa(0) And aa(0) = rd(0)) Then
    TypeAngle = "angle"

ElseIf (ld(1) = aa(1) And aa(1) <> rd(1)) Or (ld(1) <> aa(1) And aa(1) = rd(1)) Then
    TypeAngle = "angle"
Else
    '(o- o1) / (o2 - o1) = (o - o1) / (o2 - o1)
    
    us1 = Abs(ld(0) - aa(0))
    us2 = Abs(rd(0) - aa(0))
    
    us3 = Abs(ld(1) - aa(1))
    us4 = Abs(rd(1) - aa(1))
    
    If Abs((us1 / us2) - (us3 / us4)) <= 0.1 Then
        d1 = aa(0) - ld(0): d1 = trimval(d1)
        d2 = rd(0) - aa(0): d2 = trimval(d2)
        d3 = aa(1) - rd(1): d3 = trimval(d3)
        d4 = ld(1) - aa(1): d4 = trimval(d4)
        If d1 = d2 And d3 = d4 Then
            TypeAngle = "symmetrical"
        Else
            TypeAngle = "smooth"
        End If
    Else
        TypeAngle = "angle"
    End If
End If


Select Case TypeAngle

    Case "without handles"
        newCMYKColor.Cyan = 0:
        newCMYKColor.Magenta = 0
        newCMYKColor.Yellow = 0
        newCMYKColor.Black = 20
    
    Case "only one handle"
        newCMYKColor.Cyan = 16
        newCMYKColor.Magenta = 37
        newCMYKColor.Yellow = 58
        newCMYKColor.Black = 0
    
    Case "symmetrical"
        newCMYKColor.Cyan = 0
        newCMYKColor.Magenta = 100
        newCMYKColor.Yellow = 0
        newCMYKColor.Black = 0
    
    Case "smooth"
        newCMYKColor.Cyan = 100
        newCMYKColor.Magenta = 0
        newCMYKColor.Yellow = 0
        newCMYKColor.Black = 0
    
    Case "angle"
        newCMYKColor.Cyan = 100
        newCMYKColor.Magenta = 0
        newCMYKColor.Yellow = 100
        newCMYKColor.Black = 0
    
End Select

End Sub

Private Function trimval(d)
    If Not IsNumeric(Left(d, 1)) Then n = 1
    s = CStr(d)
    s = Replace(s, ",", ".")
    d = InStr(s, ".")
    If d = 0 Then
        d = CDbl(s)
    Else
        s = Left(s, d + 1 + n)
        s = Replace(s, ".", ",")
        d = CDbl(s)
    End If
    trimval = d
End Function
